var updateShown = false;
var animation_update = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function animate_update()
{
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation_update.starttime, 0, animation_update.duration);
	
	if (T >= animation_update.duration){
		clearInterval (animation_update.timer);
		animation_update.timer = null;
		animation_update.now = animation_update.to;
	}
	else{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation_update.duration));
		animation_update.now = computeNextFloat (animation_update.from, animation_update.to, ease);
	}
	
	animation_update.element.style.opacity = animation_update.now;
}


function mousemove()
{
	if (!updateShown){
		// fade in the flip widget
		if (animation_update.timer != null){
			clearInterval (animation_update.timer);
			animation_update.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation_update.duration = 500;
		animation_update.starttime = starttime;
		animation_update.element = document.getElementById ('update_data');
		animation_update.timer = setInterval ("animate_update();", 13);
		animation_update.from = animation_update.now;
		animation_update.to = 1.0;
		animate_update();
		updateShown = true;
	}
}

function mouseexit()
{
	if (updateShown)
	{
		// fade in the flip widget
		if (animation_update.timer != null)
		{
			clearInterval (animation_update.timer);
			animation_update.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation_update.duration = 500;
		animation_update.starttime = starttime;
		animation_update.element = document.getElementById ('update_data');
		animation_update.timer = setInterval ("animate_update();", 13);
		animation_update.from = animation_update.now;
		animation_update.to = 0.0;
		animate_update();
		updateShown = false;
	}
}